import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogCGI'] = []
    nbr = 0
    for obj in [x for x in resources_dict.values() if x.is_process() and Exists(reads_from(x))                     and Exists(writes_to(x)) and Exists(x.with_binds)]:
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogCGI, [], {})
        obj_coll_names = ['r1']
        r1__just = [c.range for c in obj.out_edges if c.action in ["activate", "clone"]]
        if empty(r1__just):
            continue
        r1__items = next_classes_with_justifications(None,r1__just)
        for r1 in r1__items.keys():
            r1__evidence = r1__items[r1]
            r1Player = Player(r1, 'r1', -1,RecogCGI,r1__evidence, {})
            r1_coll_names = ['shell']
            shell__just = [f for f in r1.out_to() if f != obj]
            if empty(shell__just):
                continue
            shell__items = next_classes_with_justifications(None,shell__just)
            for shell in shell__items.keys():
                shell__evidence = shell__items[shell]
                shellPlayer = Player(shell, 'shell', -1,RecogCGI,shell__evidence, {})
                shell_coll_names = ['script']
                script__just = [c for c in shell.executing if c not in [obj, shell] and Exists([f for f in c.in_from() if contains_str(f.name, "cgi")])]
                if empty(script__just):
                    continue
                script__items = next_classes_with_justifications(None,script__just)
                for script in script__items.keys():
                    script__evidence = script__items[script]
                    scriptPlayer = Player(script, 'script', -1,RecogCGI,script__evidence, {})
                    script_coll_names = []
                    if empty(setdiff(script_coll_names,scriptPlayer.with.keys())):
                        dict_put(shellPlayer.with,'script',scriptPlayer)
                if empty(setdiff(shell_coll_names,shellPlayer.with.keys())):
                    dict_put(r1Player.with,'shell',shellPlayer)
            if empty(setdiff(r1_coll_names,r1Player.with.keys())):
                dict_put(objPlayer.with,'r1',r1Player)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogCGI'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogCGI']
